automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH 2/5] New test silentyacc.test (Automake/Yacc silent-mode).


From: Stefano Lattarini
Subject: [PATCH 2/5] New test silentyacc.test (Automake/Yacc silent-mode).
Date: Thu, 22 Apr 2010 22:26:17 +0200
User-agent: KMail/1.12.1 (Linux/2.6.30-2-686; KDE/4.3.4; i686; ; )

New test `silentyacc.test': checks Automake silent-mode with Yacc.

* tests/silentyacc.test: New test.
* tests/Makefile.am (TESTS): Updated accordingly.
From 18460a891387aa84b7a92a9e5b8401da8202ae0a Mon Sep 17 00:00:00 2001
From: Stefano Lattarini <address@hidden>
Date: Thu, 22 Apr 2010 21:08:10 +0200
Subject: [PATCH 2/5] New test silentyacc.test (Automake/Yacc silent-mode).

* tests/silentyacc.test: New test.
* tests/Makefile.am (TESTS): Updated accordingly.
---
 ChangeLog             |    4 ++
 tests/Makefile.am     |    1 +
 tests/Makefile.in     |    1 +
 tests/silentyacc.test |  111 +++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 117 insertions(+), 0 deletions(-)
 create mode 100755 tests/silentyacc.test

diff --git a/ChangeLog b/ChangeLog
index aaf8103..b810f6d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,9 @@
 2010-04-22  Stefano Lattarini  <address@hidden>
 
+       New test `silentyacc.test' (Automake silent-mode with Yacc).
+       * tests/silentyacc.test: New test.
+       * tests/Makefile.am (TESTS): Updated accordingly.
+
        New test `silentlex.test' (Automake silent-mode with Lex).
        * tests/silentlex.test: New test.
        * tests/Makefile.am (TESTS): Updated accordingly.
diff --git a/tests/Makefile.am b/tests/Makefile.am
index c945ebe..600eda6 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -625,6 +625,7 @@ silent7.test \
 silent8.test \
 silent9.test \
 silentlex.test \
+silentyacc.test \
 sinclude.test \
 srcsub.test \
 srcsub2.test \
diff --git a/tests/Makefile.in b/tests/Makefile.in
index e93c616..5fb8bd1 100644
--- a/tests/Makefile.in
+++ b/tests/Makefile.in
@@ -866,6 +866,7 @@ silent7.test \
 silent8.test \
 silent9.test \
 silentlex.test \
+silentyacc.test \
 sinclude.test \
 srcsub.test \
 srcsub2.test \
diff --git a/tests/silentyacc.test b/tests/silentyacc.test
new file mode 100755
index 0000000..3704fd7
--- /dev/null
+++ b/tests/silentyacc.test
@@ -0,0 +1,111 @@
+#!/bin/sh
+# Copyright (C) 2010 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Check silent-rules mode for Yacc.
+
+required='bison'
+. ./defs
+
+set -e
+
+mkdir sub
+
+cat >>configure.in <<'EOF'
+AM_SILENT_RULES
+AM_PROG_CC_C_O
+AC_PROG_YACC
+AC_CONFIG_FILES([sub/Makefile])
+AC_OUTPUT
+EOF
+
+cat > Makefile.am <<'EOF'
+# Need generic and non-generic rules.
+bin_PROGRAMS = foo1 foo2
+foo1_SOURCES = foo.y
+foo2_SOURCES = $(foo1_SOURCES)
+foo2_CFLAGS = $(AM_CPPFLAGS)
+SUBDIRS = sub
+EOF
+
+cat > sub/Makefile.am <<'EOF'
+AUTOMAKE_OPTIONS = subdir-objects
+# Need generic and non-generic rules.
+bin_PROGRAMS = bar1 bar2
+bar1_SOURCES = bar.y
+bar2_SOURCES = $(bar1_SOURCES)
+bar2_CFLAGS = $(AM_CPPFLAGS)
+EOF
+
+cat > foo.y <<'EOF'
+%{
+void yyerror (char *s) {}
+int yylex (void) {return 0;}
+int main(void) {return 0;}
+%}
+%token EOF
+%%
+fubar : 'f' 'o' 'o' 'b' 'a' 'r' EOF {};
+EOF
+cp foo.y sub/bar.y
+
+$ACLOCAL
+$AUTOMAKE --add-missing
+$AUTOCONF
+
+# configure once for fastdep, once for non-fastdep, once for nodep
+for config_args in \
+  '' \
+  am_cv_CC_dependencies_compiler_type=gcc \
+  --disable-dependency-tracking
+do
+  ./configure $config_args --enable-silent-rules
+  $MAKE >stdout || { cat stdout; Exit 1; }
+  cat stdout
+  grep ' -c' stdout && Exit 1
+  grep ' -o' stdout && Exit 1
+  grep mv stdout && Exit 1
+
+  grep 'YACC .*foo\.' stdout
+  grep 'YACC .*bar\.' stdout
+  grep ' CC .*foo\.' stdout
+  grep ' CC .*bar\.' stdout
+  $EGREP 'CCLD .*foo1' stdout
+  $EGREP 'CCLD .*bar1' stdout
+  $EGREP 'CCLD .*foo2' stdout
+  $EGREP 'CCLD .*bar2' stdout
+
+  # Ensure a clean rebuild.
+  $MAKE clean
+  rm -f foo.[ch] sub/bar.[ch]
+
+  $MAKE V=1 >stdout || { cat stdout; Exit 1; }
+  cat stdout
+  grep ' -c ' stdout
+  grep ' -o ' stdout
+
+  grep 'YACC '  stdout && Exit 1
+  grep 'YACC '  stdout && Exit 1
+  grep 'CC '    stdout && Exit 1
+  grep 'CCLD '  stdout && Exit 1
+
+  # Ensure a clean reconfiguration/rebuild.
+  $MAKE clean
+  $MAKE maintainer-clean
+  rm -f foo.[ch] sub/bar.[ch]
+
+done
+
+:
-- 
1.6.5


reply via email to

[Prev in Thread] Current Thread [Next in Thread]